#!/usr/bin/perl
#
# UNIX debugger tracebacks
#
#
#    ========== licence begin  GPL
#    Copyright (C) 2001 SAP AG
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#    ========== licence end
#

use Env;

if ( @ARGV < 1 )
{
   print "traceback program [core]\n";
   print "if no core specified, ./core is used\n";
   exit 1;
}

my $PROG=shift;
if ( @ARGV >= 1 )
{
    $CORE=shift;
}
else
{
    $CORE='./core';
}

print "\n-------------Begin of Stack backtrace\n";

 open(FILE_OUT, "|gdb -q $PROG $CORE");
 print FILE_OUT "where\n";
print FILE_OUT "quit\n";
close(FILE_OUT);

print "\n-------------End of Stack backtrace\n";
